<?php
/*
    LWAT, LDAP Webbased Administration Tool
    Copyright (C) 2007  Finn-Arne Johansen <faj@bzz.no>, Bzzware AS, Norway

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
require_once ('functions.php') ;
require_once ('/etc/lwat/config.php') ;
loadLocale () ; 
ob_start () ; 

?>
<html>
<head>
    <title>Reset Password</title>
</head>
<body>
<?php

$want= array ("cn", "uid");
if (!($connect = ldap_connect ($ldaphost))) 
    die ("Could not connect to ldap server") ; 
ldap_set_option($connect, LDAP_OPT_PROTOCOL_VERSION, 3);
ldap_start_tls ($connect) ; 

$name=trim($_GET['username']) ; 

if (empty($name))
    $action=readKey('Action') ; 
else 
    $action="searchFor" ; 

switch ($action) {
    case "searchFor":
	if ($bind = ldap_bind ($connect)) { 
	    if (empty ($name)) {
	        $name=readKey ('name') ;
	        $filter="(&(objectClass=posixAccount)" . 
	                "(|(uid=$name*)(cn=$name*)))" ; 
	    } else
	        $filter="(&(objectClass=posixAccount)(uid=$name))" ; 
	    $result= ldap_search ($connect, $base, $filter, $want);
	    $entries = ldap_get_entries ($connect, $result);
	    switch ($entries["count"]) {
		case 0:
		    echo "<H3>";
		    printf (_("No such user"));
		    echo "</H3>";
		    printf (_("Sorry, could not find any users by the search  %s."),$filter); 
		    echo "<BR>"; 
		    break ;
		case 1:
		    echo "<H3>";
		    printf (_("Change password for user"));
		    echo "</H3>";
		    echo "<form action=chguserpw.php method=post>\n" ; 
		    echo "<input type=hidden name=userdn value='" . $entries[0]['dn'] . "'>\n";
		    printf (_("Change password for %s ( %s ).") ."<BR>\n",$entries[0]['uid'][0], $entries[0]['cn'][0]);
		    printf (_("Enter your old password:"));  
		    echo "<input type=password name=oldpw><BR>\n";
		    printf (_("Enter your new password:"));
		    echo "<input type=password name=userpw><BR>\n" ; 
		    printf (_("Repeat the new password:"));
		    echo "<input type=password name=chkpw><BR>\n" ; 
		    echo "<input type=hidden name=Action value=setpw>\n" ; 
		    echo '<input type=SUBMIT name=setpw value="' ; 
		    printf (_("Set password")) ;
		    echo '">';
		    echo "</form><HR>";
		    break ;
		default:
		    echo "<H3>";
		    printf (_("Select User"));
		    echo "</H3>";
		    foreach ($entries as $i => $entry) {
			if ($entry["uid"][0]) {
			    echo "<A HREF='chguserpw.php?username=" . $entry["uid"][0] . "'> " ;
			    echo $entry["cn"][0] . "</A><BR>" ; 
			}
		    }
		    break ;
	    }
	}
        break ;
    case "setpw":
	$newpw = readKey('userpw') ; 
	$oldpw = readKey('oldpw') ; 
	$userdn = readKey('userdn') ; 
	$cryptpw = cryptgen ($newpw); 
	$sambahash = ntlmgen ($newpw) ;
	$info = array ();
	$info["userPassword"][] = $cryptpw ;
	$info["sambaLMPassword"][] = substr ($sambahash, 0,32) ;
	$info["sambaNTPassword"][] = substr ($sambahash, 32) ;
	if ($bind = ldap_bind ($connect)) {
	    $result= ldap_search ($connect, $base, $filter, $want);
	    $entries = ldap_get_entries ($connect, $result);
	    if ($entries[count] == 1) {
		$entry = $entries[0];
		$admindn = $entry["dn"];
	    }
	    $bind = ldap_bind ($connect,$userdn,$oldpw) ;
	}
	if (! $bind)
	    printf (_("Sorry. I'm not able to connect as  %s.") . "<br />" , $userdn );
	else {
	    $result = ldap_modify ($connect,$userdn,$info) ;
	    if ($result)
		printf (_("Changed password for  %s to %s.") . "<br />" , $userdn,$newpw);
	    else
		printf (_("Failed to change password for  %s.") . "<br />" ,$userdn);
	}
	break ;
    case "Oldmethod":
	foreach ($_POST as $key => $value){
	    switch ($key) {
		case "admindn":
		    $admindn=$value ;
		    break ;
		case "adminpw":
		    $adminpw=$value ;
		    break ;
		case "setpw":
		    $filter="(&(objectClass=posixAccount)(uid=$admindn))";
		    $newpw = pwgen (); 
		    $cryptpw = cryptgen ($newpw); 
		    $sambahash = ntlmgen ($newpw) ;
		    $info = array ();
		    $info["userPassword"][] = $cryptpw ;
		    $info["sambaLMPassword"][] = substr ($sambahash, 0,32) ;
		    $info["sambaNTPassword"][] = substr ($sambahash, 32) ;
		    $tod = gettimeofday () ;
		    $info["sambaPwdMustChange"][] = $tod["sec"] ;
		    if ($bind = ldap_bind ($connect)) {
			$result= ldap_search ($connect, $base, $filter, $want);
			$entries = ldap_get_entries ($connect, $result);
			if ($entries[count] == 1) {
			    $entry = $entries[0];
			    $admindn = $entry["dn"];
			}
			$bind = ldap_bind ($connect,$admindn,$adminpw) ;
		    }
		    if (! $bind)
			printf (_("Sorry. I'm not able to connect as  %s.") . "<br />" , $admindn );
		    else {
			$result = ldap_modify ($connect,$userdn,$info) ;
			if ($result)
			    printf (_("Changed password for  %s to %s.") . "<br />" , $userdn,$newpw);
			else
			    printf (_("Failed to change password for  %s.") . "<br />" ,$userdn);
		    }
		    break ;
		case "userdn":
		    $filter="(&(objectClass=posixAccount)(uid=$value))";
		    $userdn=$value ;
		    break ;
		case "SearchFor":
		    $filter="(&(objectClass=posixAccount)(|(uid=$value*)(cn=$value*)))";
		    $searchfor=$value ;
		    break ;
	    }
	}
	break ;
    default:
	echo "<form action=chguserpw.php method=\"POST\"><H3>";
	printf (_("Username or Fullname:"));
	echo "</H3>";
	echo "<input type=hidden name=Action value=searchFor>" ; 
	echo "<INPUT TYPE=text name=name><BR><BR>";
	printf ("<INPUT TYPE=submit name=submit value=" . _("search") . "><br />" );
	printf ( "<INPUT TYPE=reset name=CANCEL value=" . _("reset") . "><br /><H3>" );
	printf ( "<H3>" . _("Tips:") . "</H3>" );
	printf (_("By default it searches for partial name, but adds wildcard at the end") . "<br />" );
	printf (_("Add an asterisk at the beginning to add a wildcard at the beginning") . "<br /></form></body></html>" );
	break ;
}
    ldap_close ($connect) ; 
?>
